Bug 1541921 - cachetune cannot work with TCG guest
Summary: cachetune cannot work with TCG guest
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: libvirt
Version: 7.5
Hardware: x86_64
OS: Linux
medium
medium
Target Milestone: rc
: ---
Assignee: Michal Privoznik
QA Contact: jiyan
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2018-02-05 08:35 UTC by Luyao Huang
Modified: 2018-10-30 09:54 UTC (History)
3 users (show)

Fixed In Version: libvirt-4.5.0-1.el7
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-10-30 09:52:39 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2018:3113 None None None 2018-10-30 09:54:42 UTC

Description Luyao Huang 2018-02-05 08:35:46 UTC
Description of problem:
cachetune work not well with TCG guest

Version-Release number of selected component (if applicable):
libvirt-3.9.0-11.el7.x86_64

How reproducible:
100%

Steps to Reproduce:
1. prepare a TCG guest with cachetune:

<domain type='qemu'>
  <name>vm1</name>
  <uuid>f98741e7-ddad-4be1-82c0-0ae3655d1c25</uuid>
  <memory unit='KiB'>1024000</memory>
  <currentMemory unit='KiB'>1024000</currentMemory>
  <vcpu placement='static' cpuset='0-2' current='2'>4</vcpu>
  <cputune>
    <cachetune vcpus='0'>
      <cache id='0' level='3' type='both' size='1' unit='MiB'/>
      <cache id='1' level='3' type='both' size='2' unit='MiB'/>
    </cachetune>
    <cachetune vcpus='1'>
      <cache id='0' level='3' type='both' size='2' unit='MiB'/>
      <cache id='1' level='3' type='both' size='1' unit='MiB'/>
    </cachetune>
    <cachetune vcpus='3'>
      <cache id='0' level='3' type='both' size='1' unit='MiB'/>
      <cache id='1' level='3' type='both' size='1' unit='MiB'/>
    </cachetune>
  </cputune>


2. start guest:

# virsh start vm1
Domain vm1 started

3. check the resctrl tasks binding status, and there is no task id in these dir:

# cat /sys/fs/resctrl/qemu-5-vm1-vcpus_0/tasks
# cat /sys/fs/resctrl/qemu-5-vm1-vcpus_1/tasks
# cat /sys/fs/resctrl/qemu-5-vm1-vcpus_3/tasks


Actual results:

Libvirt create 3 dir for vcpus 0,1,3, but doesn't set the cpu thread in the tasks, and also TCG only have one thread for all cpus, libvirt cannot put each vcpu in these 3 dir

Expected results:

1. report error with machine type is qemu:

error: operation failed: Virt type 'qemu' does not support cachetune

or 2. allow put all vcpus in one group


Additional info:

Comment 1 Michal Privoznik 2018-06-28 12:46:11 UTC
Patch proposed upstream:

https://www.redhat.com/archives/libvir-list/2018-June/msg01800.html

Comment 2 Michal Privoznik 2018-06-28 15:08:16 UTC
I've just pushed the patch upstream:

commit cb7a4ac4fb9e32f620d800036b1abdd4bed09ce6
Author:     Michal Privoznik <mprivozn@redhat.com>
AuthorDate: Thu Jun 28 11:37:09 2018 +0200
Commit:     Michal Privoznik <mprivozn@redhat.com>
CommitDate: Thu Jun 28 17:06:52 2018 +0200

    qemu: Allow cachetune only for KVM domains
    
    https://bugzilla.redhat.com/show_bug.cgi?id=1541921
    
    In TCG mode, there are no vCPU threads and thus there's nothing
    to be placed into resctrl group. Forbid such configuration.
    
    Signed-off-by: Michal Privoznik <mprivozn@redhat.com>
    Reviewed-by: Daniel P. Berrangé <berrange@redhat.com>

v4.5.0-rc1-7-gcb7a4ac4fb

Comment 4 jiyan 2018-07-09 02:51:40 UTC
Verified this bug on the following components:
qemu-kvm-rhev-2.12.0-7.el7.x86_64
libvirt-4.5.0-1.el7.x86_64
kernel-3.10.0-919.el7.x86_64

Steps:
1. Edit VM with the following configuration and try to save it
# virsh edit b1
<domain type='qemu'>
...
  <cputune>
    <cachetune vcpus='0'>
      <cache id='0' level='3' type='both' size='1' unit='MiB'/>
      <cache id='1' level='3' type='both' size='2' unit='MiB'/>
    </cachetune>
    <cachetune vcpus='1'>
      <cache id='0' level='3' type='both' size='2' unit='MiB'/>
      <cache id='1' level='3' type='both' size='1' unit='MiB'/>
    </cachetune>
    <cachetune vcpus='3'>
      <cache id='0' level='3' type='both' size='1' unit='MiB'/>
      <cache id='1' level='3' type='both' size='1' unit='MiB'/>
    </cachetune>
  </cputune>
...
error: unsupported configuration: cachetune is only supported for KVM domains
Failed. Try again? [y,n,i,f,?]:

The error info raised, which is expected. So move this bug to be verified.

Comment 6 errata-xmlrpc 2018-10-30 09:52:39 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2018:3113


Note You need to log in before you can comment on or make changes to this bug.